stages:
  - make
  - container
  - test
  - package
  - push

#debian-packaging:
#  stage: make
#  image: debian:bullseye
#  variables:
#    TOOL_ARGS: apt-get -o Debug::pkgProblemResolver=yes --no-install-recommends --yes
#  before_script:
#    - export PATH="$PATH:/usr/lib/go-1.12/bin"
#    - apt-get update
#    - apt-get install -y devscripts dpkg-sig gnupg curl
#  script:
#    - mk-build-deps --install --tool="$TOOL_ARGS" debian/control
#    - make tools
#    - ./build-deb.sh
#    - make
#  after_script:
#    - cd debian
#    - ./cleanup.sh
#    - cd ..
#    - chmod 777 build
#    - chmod 777 .tools
#  artifacts:
#    paths:
#      - build
#      - .tools
#  tags:
#    - merge
#    - docker

make:
  stage: make
  image: registry.gitlab.com/mergetb/devops/builder/f33-cib
  variables:
    GOPROXY: http://ci.mergetb.net:3000
  script:
    - dnf install -y make
    - make tools
    - make
  artifacts:
    paths:
      - build/*
  tags:
    - merge
    - docker

container:
  stage: container
  script:
    - >
      podman build --no-cache -f container/Dockerfile 
      -t registry.gitlab.com/mergetb/tech/foundry/foundry:$CI_COMMIT_REF_NAME .
  dependencies:
    - make
  tags:
    - merge
    - shell

#test-debian-package:
#  stage: test
#  before_script:
#    - cd test
#    - sudo rvn destroy
#  script:
#    - sudo DEB_PACKAGE=1 ./run.sh
#  after_script:
#    - cd test
#    - sudo rvn destroy
#  dependencies:
#    - debian-packaging
#  tags:
#    - merge
#    - shell

#package:
#  stage: package
#  image: debian:bullseye
#  before_script:
#    - apt-get update
#    - apt-get install -y devscripts dpkg-sig gnupg curl
#    - 'curl -L https://gitlab.com/mergetb/devops/pkg/raw/master/add-deb.sh > add-deb.sh'
#    - 'chmod +x add-deb.sh'
#    - echo $MERGETB_GPG_KEY | base64 -di | gpg --import
#    - echo $MERGETB_GPG_PUBKEY | base64 -di | gpg --import
#  script:
#    - find . -name "*.deb" | xargs -n 1 dpkg-sig -k $MERGETB_GPG_KEY_ID --sign builder
#    - find . -name "*.deb" | RELEASE=buster xargs -n 1 ./add-deb.sh
#    - find . -name "*.deb" | RELEASE=bullseye xargs -n 1 ./add-deb.sh
#  dependencies:
#    - debian-packaging
#  tags:
#    - merge
#    - docker
#  only:
#    - tags

push:
  stage: push
  script:
    - podman login -u registry_token -p $REGISTRY_TOKEN registry.gitlab.com
    - podman push registry.gitlab.com/mergetb/tech/foundry/foundry:$CI_COMMIT_REF_NAME
  dependencies:
    - make
  tags:
    - merge
    - shell
